<template>
  <AtomAutocomplete
    :label="label"
    :name="name"
    :search-fn="searchAddressesFn"
    :value="selectedValue"
    :required="required"
    @result-selected="onSelectAddress"
  />
</template>

<script lang="ts" setup>
  type BanAddress = {
    id: string
    name: string
    postcode: string
    city: string
    context: string
  }
  type BanResponse = { features: Array<{ properties: BanAddress }> }

  const { $request } = useNuxtApp()

  const props = withDefaults(
    defineProps<{
      name: string
      value?: string
      label: string
      required?: boolean
      zipCode?: string
    }>(),
    { value: '', required: false, zipCode: '' }
  )

  const emit = defineEmits<{
    (
      e: 'addressSelected',
      address: { zipCode: string; city: string; region: string }
    ): void
  }>()

  const addresses = ref<BanAddress[]>([])
  const selectedValue = ref<string>(props.value)

  async function searchAddressesFn(
    search: string
  ): Promise<Map<string, string>> {
    if (search.length < 3) return new Map()

    const params = new URLSearchParams({
      q: search,
      limit: '3'
    })
    if (props.zipCode) params.append('postcode', props.zipCode)

    const res = await $request<BanResponse>(
      `https://api-adresse.data.gouv.fr/search/?${params}`
    )

    // Use res.ok for type inference
    if (res.ok && res.status === 200) {
      addresses.value = res.data.features.map(({ properties }) => properties)
      return new Map(
        addresses.value.map(({ id, name, postcode, city }) => [
          id,
          `${name}, ${postcode} ${city}`
        ])
      )
    }
    throw new Error(res.data.errors[0].message)
  }

  function onSelectAddress(addressId: string) {
    const address = addresses.value.find(a => a.id === addressId)
    if (!address) return
    selectedValue.value = address.name
    const region = address.context.split(',')[2].trim()
    emit('addressSelected', {
      zipCode: address.postcode,
      city: address.city,
      region
    })
  }
</script>
